Subject: Re: pg_basebackup WAL streamer shutdown is bogus - leading to slow tests

From: Tom Lane <[email-masked]>
Date: Sun, 16 Jan 2022 11:34:42 -0500

Andres Freund <[email-masked]> writes:
> I don't immediately see a solution for this, other than to add
> StreamCtl->stop_event (mirroring ->stop_socket) and then convert
> CopyStreamPoll() to use WaitForMultipleObjects().  Microsoft's select()
> doesn't support pipes and there's no socketpair().
> Any more straightforward ideas?
> From a cursory look at history, it used to be that pg_basebackup had this
> behaviour on all platforms, but it got fixed for other platforms in
> 7834d20b57a by Tom (assuming the problem wasn't present there).

Hmm --- I see that I thought Windows was unaffected, but I didn't
consider this angle.

Can we send the child process a signal to kick it off its wait?

			regards, tom lane